
// -----------------------------------
// Fahrbefele erzeugen
// -----------------------------------

public void generateCommands(){

  command_list.clear();
  generatePoints();

  //COMMAND_LIST ERZEUGEN -----------------------

  // variablen, die sich von der form letzte daten merken, um den anschluss zu machen
  // start bei 0 0 mit blick nach rechts
  float last_path_x=0.0;
  float last_path_y=0.0;
  float lastlast_path_x=-1.0;
  float lastlast_path_y=0.0;
  
  if(rawGroupedPoints!=null){
    for (int i=0; i<rawGroupedPoints.length; i++) {
    
      // stift hoch
      command_list.append(5.0);
      command_list.append(1.0);
    
      // zum ersten punkt des elements fahren
      command_list.append(4.0); // drehen
      command_list.append(calcAngle(
        lastlast_path_x, lastlast_path_y, // startpunkt auf dem papier, oben links, schauen nach gerade rechts, virtuell kommt er von aussen links
        last_path_x, last_path_y, 
        rawGroupedPoints[i][0].x, rawGroupedPoints[i][0].y
      ));

      command_list.append(3.0); // fahren
      command_list.append(calcDistance(
        last_path_x, last_path_y, 
        rawGroupedPoints[i][0].x, rawGroupedPoints[i][0].y
      ));

      // stift runter
      command_list.append(5.0);
      command_list.append(-1.0);

      // zeichnen
      for (int ii=0; ii<rawGroupedPoints[i].length-2; ii++) {

        // zum ersten punkt des elements fahren

        command_list.append(4.0); // drehen
        command_list.append(calcAngle(
          ii>0 ? rawGroupedPoints[i][ii-1].x : last_path_x, ii>0 ? rawGroupedPoints[i][ii-1].y : last_path_y, 
          rawGroupedPoints[i][ii].x, rawGroupedPoints[i][ii].y, 
          rawGroupedPoints[i][ii+1].x, rawGroupedPoints[i][ii+1].y
        ));

        command_list.append(3.0); // fahren
        command_list.append(calcDistance(
          rawGroupedPoints[i][ii].x, rawGroupedPoints[i][ii].y, 
          rawGroupedPoints[i][ii+1].x, rawGroupedPoints[i][ii+1].y
        ));
      }

      // stift hoch
      command_list.append(5.0);
      command_list.append(1.0);

      // letze daten merken
      last_path_x=rawGroupedPoints[i][rawGroupedPoints[i].length-2].x;
      last_path_y=rawGroupedPoints[i][rawGroupedPoints[i].length-2].y;
      lastlast_path_x=rawGroupedPoints[i][rawGroupedPoints[i].length-3].x;
      lastlast_path_y=rawGroupedPoints[i][rawGroupedPoints[i].length-3].y;
      
    }

    // zum start punkt zurück fahren fahren
    command_list.append(4.0); // drehen
    command_list.append(calcAngle(
      lastlast_path_x, lastlast_path_y, // startpunkt auf dem papier, oben links, schauen nach gerade rechts, virtuell kommt er von aussen links
      last_path_x, last_path_y, 
      0, 0
    ));

    command_list.append(3.0); // fahren
    command_list.append(calcDistance(
      last_path_x, last_path_y, 
      0, 0
    ));

    command_list.append(4.0); // richtung rechts drehen
    command_list.append(calcAngle(
      last_path_x, last_path_y, // startpunkt auf dem papier, oben links, schauen nach gerade rechts, virtuell kommt er von aussen links
      0, 0, 
      1, 0 // gerade nach rechts
    ));

    for (int i=0; i<command_list.size()/2; i++) { // alle leeren einträge entfernen
      if (command_list.get(i*2+1)==0.0) {
        command_list.remove(i*2);
        command_list.remove(i*2);
      }
    }
  
    command_list_length=command_list.size()/2;
    
  }
}

float calcDistance(float a_x, float a_y, float b_x, float b_y) { // Abstand zwischen 2 Punkten
  return sqrt(sq(a_x-b_x)+sq(a_y-b_y)); //Phytagoras
}

float calcAngle(float a_x, float a_y, float b_x, float b_y, float c_x, float c_y) { // a-1, b, c+1

  float angle1;
  float angle2;

  angle1 = atan2(a_y-b_y, a_x-b_x);
  angle2 = atan2(b_y-c_y, b_x-c_x);

  float angle=degrees(angle2-angle1);

  if (angle<-180) {
    angle=360+angle;
  }

  if (angle>180) {
    angle=angle-360;
  }

  return angle;
}
