
// -----------------------------------
// manuellTouch
// -----------------------------------


float current_vertical=0;
float current_horizontal=0;

float speed_left=0;
float speed_right=0;

float old_speed_left=0;
float old_speed_right=0;

// Beschl und touch --------------------------------------------------------------------------

public void manuellTouchOscEvent(OscMessage theOscMessage) {
  
  // Gyro --------- 
  if (theOscMessage.addrPattern().contains("/accxyz")) {
    //println(theOscMessage.arguments()[0]+" "+theOscMessage.arguments()[1]+" "+theOscMessage.arguments()[2]); 

    current_horizontal=(Float)theOscMessage.arguments()[1]*1.8;
    if (current_horizontal>0.0) {
      current_horizontal=current_horizontal-0.2;
      if (current_horizontal<0.0) {
        current_horizontal=0.0; 
      }
    } else if (current_horizontal<0.0) {
      current_horizontal=current_horizontal+0.2;
      if (current_horizontal>0.0) {
        current_horizontal=0.0; 
      }
    }
    if (current_horizontal>1.0) {
       current_horizontal=1.0;
    }
    if (current_horizontal<-1.0) {
       current_horizontal=-1.0;
    }
      
    current_vertical=(Float)theOscMessage.arguments()[0]*1.8;
    if (current_vertical>0.0) {
      current_vertical=current_vertical-0.2;
      if (current_vertical<0.0) {
        current_vertical=0.0; 
      }
    } else if (current_vertical<0.0) {
      current_vertical=current_vertical+0.2;
      if (current_vertical>0.0) {
        current_vertical=0.0; 
      }
    }
    if (current_vertical>1.0) {
       current_vertical=1.0;
    }
    if (current_vertical<-1.0) {
       current_vertical=-1.0;
    }

    updateSpeed();

  }
   
  // Fader --------- 

  if (theOscMessage.addrPattern().contains("/ml/mt/horizontal")) {
    
    current_horizontal=(Float)theOscMessage.arguments()[0];
    if (current_horizontal>0.0) {
      current_horizontal=current_horizontal-0.2;
      if (current_horizontal<0.0) {
        current_horizontal=0.0; 
      }
    } else if (current_horizontal<0.0) {
      current_horizontal=current_horizontal+0.2;
      if (current_horizontal>0.0) {
        current_horizontal=0.0; 
      }
    }
    updateSpeed();

  }
 
  if (theOscMessage.addrPattern().contains("/ml/mt/vertical")) {

    current_vertical=(Float)theOscMessage.arguments()[0];
    if (current_vertical>0.0) {
      current_vertical=current_vertical-0.2;
      if (current_vertical<0.0) {
        current_vertical=0.0; 
      }
    } else if (current_vertical<0.0) {
      current_vertical=current_vertical+0.2;
      if (current_vertical>0.0) {
        current_vertical=0.0; 
      }
    }
    updateSpeed();

  }
  
  
  // Pen --------- 

  if (theOscMessage.addrPattern().contains("/ml/mt/pen")) {
    
    println("pen "+(Float)theOscMessage.arguments()[0]);

    // pen an malokal weiterleiten
    OscMessage message = new OscMessage("/ml/mt/pen"); 
    message.add((Float)theOscMessage.arguments()[0]);
    malokalSendOSC(message);   
  
  }
  
}

// Geschwindigkeit --------------------------------------------------------------------------

int last_updateSpeed_millis=millis();



void updateSpeed() {
  
  speed_left=round(current_vertical*500.0+current_horizontal*-1*500.0);  
  speed_right=round(current_vertical*500.0+current_horizontal*500.0);
  
  if (speed_left>500.0) {
     speed_left=500.0; 
  }
  if (speed_left<-500.0) {
     speed_left=-500.0; 
  }
  
  if (speed_right>500.0) {
     speed_right=500.0; 
  }
  if (speed_right<-500.0) {
     speed_right=-500.0; 
  }
  
  //if (millis()-last_updateSpeed_millis>50) { // nach 10 sekunden deaktivieren
  
  float grenze=5.0;

  if ( 
      (speed_left-old_speed_left>grenze||speed_left-old_speed_left<-grenze)||
      (speed_right-old_speed_right>grenze||speed_right-old_speed_right<-grenze)

    ) {
  
last_updateSpeed_millis=millis();
  println("left "+speed_left+" right "+speed_right);
  
  // geschwindigkeit an malokal weiterleiten
  OscMessage message = new OscMessage("/ml/mt/speed"); 
  message.add(speed_left);
  message.add(speed_right);
  malokalSendOSC(message);   
  
  old_speed_left=speed_left;
  old_speed_right=speed_right;

  }
  
}

