
// -----------------------------------
// OSC
// ----------------------------------

public void oscEvent(OscMessage theOscMessage) {
  
  // an manuellTouch durchleiten
  manuellTouchOscEvent(theOscMessage);
  
  // Anfrage von Malokal
  if(theOscMessage.addrPattern().equals("/ml/alive")){
    is_malokal_available=true;
    last_malokal_available=millis();
 
    is_malokal_pause=(Integer)theOscMessage.arguments()[1]==1; // int zu bool
    is_malokal_running=(Integer)theOscMessage.arguments()[2]==1;
    
    // current index abfragen
    if (is_malokal_running) {
      malokal_current_index=(Integer) theOscMessage.arguments()[0];
    } else {
      malokal_current_index=0;
    }

    please_drawPaper=true;
        
    if (is_malokal_available_first) { // malokal wird das erste mal erkannt
      is_malokal_available_first=false;    
    }

  }
  if (theOscMessage.addrPattern().equals("/ml/q/req")) {
    
    malokal_request_index=(Integer) theOscMessage.arguments()[0];  // element, das malokal anfordert  

    // Antwort
    OscMessage message = new OscMessage("/ml/q/res"); 
    message.add(malokal_request_index); // index wird zur kontrolle mitgesendet
    message.add(command_list.get(malokal_request_index*2));
    message.add(command_list.get(malokal_request_index*2+1));
    malokalSendOSC(message);      

  }
  
}

public void malokalSendOSC(OscMessage Message) {
  malokalOscP5.send(Message, malokal_location);
}

public void touchSendOSC(OscMessage Message) {
  touchOscP5.send(Message, touch_location);
}


