
// -----------------------------------
// virtuelles Papier zeichnen
// -----------------------------------

public void drawPaper(){
  
  virtual_paper_ppmm=(float)(height-control_height-virtual_paper_top*2)/(float)paper_height_mm;
  virtual_paper_left=(int)((width-paper_width_mm*virtual_paper_ppmm)/2.0);

  if (paper_width_mm*virtual_paper_ppmm>width-40) {
    virtual_paper_left=20;
    virtual_paper_ppmm=(float)(width-virtual_paper_left*2)/(float)paper_width_mm;
    virtual_paper_top=(int)((height-control_height-paper_height_mm*virtual_paper_ppmm)/2.0);
  }
  
  strokeWeight(1);

  fill(240);
  rect(0,paper_zero_height,width,height-control_height); 

  //Papier leeren
  fill(255);
  rect(virtual_paper_left,paper_zero_height+virtual_paper_top,paper_width_mm*virtual_paper_ppmm,paper_zero_height+paper_height_mm*virtual_paper_ppmm); 
  
  stroke(240);
  line(vis_left_mm*virtual_paper_ppmm+virtual_paper_left, virtual_paper_top, vis_left_mm*virtual_paper_ppmm+virtual_paper_left, virtual_paper_top+paper_height_mm*virtual_paper_ppmm);
  line(paper_width_mm*virtual_paper_ppmm-(vis_left_mm*virtual_paper_ppmm)+virtual_paper_left, virtual_paper_top, paper_width_mm*virtual_paper_ppmm-(vis_left_mm*virtual_paper_ppmm)+virtual_paper_left, virtual_paper_top+paper_height_mm*virtual_paper_ppmm);
  line(virtual_paper_left, vis_top_mm*virtual_paper_ppmm+virtual_paper_top, paper_width_mm*virtual_paper_ppmm+virtual_paper_left, vis_top_mm*virtual_paper_ppmm+virtual_paper_top);
  line(virtual_paper_left, paper_height_mm*virtual_paper_ppmm-(vis_top_mm*virtual_paper_ppmm)+virtual_paper_top, paper_width_mm*virtual_paper_ppmm+virtual_paper_left, paper_height_mm*virtual_paper_ppmm-(vis_top_mm*virtual_paper_ppmm)+virtual_paper_top);

  // Fahrweg simulieren 
  pushMatrix();
  translate(virtual_paper_left, virtual_paper_top+paper_zero_height);
  boolean is_stift_unten=false;
 // println(malokal_current_index);
  for (int i=0; i<command_list.size() /2; i++) {
    if (command_list.get(i*2)==3.0) { // fahren
    //  if (is_stift_unten) {
      
         if (i<malokal_current_index) { // schon gefahren
              stroke(0, 0, 0);
         } else {
            if (is_stift_unten) {
              if (!is_malokal_running) {
                stroke(0, 0,0);
              } else {
                stroke(230, 230,230);
              }
            } else {
              if (!is_malokal_running) {
                stroke(200, 200, 200);
              } else {
                stroke(230, 230,230);
              }
            }

         }

      line(0, 0, command_list.get(i*2+1)*virtual_paper_ppmm, 0);
      translate(command_list.get(i*2+1)*virtual_paper_ppmm, 0);
    }
    if (command_list.get(i*2)==4.0) { // drehen
      rotate(radians(command_list.get(i*2+1)));
    }    
    if (command_list.get(i*2)==5.0) { // stift
      is_stift_unten=command_list.get(i*2+1)==-1?true:false;
    }
  }
  popMatrix();

  // Punkte und Text
  for (int i=0; i<rawGroupedPoints.length; i++) {
    for (int ii=0; ii<rawGroupedPoints[i].length-1; ii++) {
      if (ii==0) { // 0 punkt
        fill(255, 0, 0);
      } else if (ii<rawGroupedPoints[i].length-2) { // nicht letzer punkt
        fill(0);
      }
      if (ii<rawGroupedPoints[i].length-2) { // nicht letzer punkt
      //  text(ii+1, rawGroupedPoints[i][ii].x*virtual_paper_ppmm+4, rawGroupedPoints[i][ii].y*virtual_paper_ppmm+3);
        noStroke();
        ellipse(virtual_paper_left+rawGroupedPoints[i][ii].x*virtual_paper_ppmm, virtual_paper_top+rawGroupedPoints[i][ii].y*virtual_paper_ppmm+paper_zero_height, 3, 3);  // punkt zeichnen
      }
    }
  }
  
  // Maße anzeigen
  fill(0);
  textFont(createFont("Helvetica Neue", 10));
  text("Papier "+paper_width_mm+"mm × "+paper_height_mm+"mm", 10,18);
  text("Objekt "+vis_width_mm+"mm × "+vis_height_mm+"mm", 10, 33);

  // Anzahl aller Punkte addieren
  int lange=0;
  for (int i=0; i<rawGroupedPoints.length; i++) {
    lange=lange+rawGroupedPoints[i].length-1;
  }
  text(lange+" Punkte, "+command_list_length+" Befehle", 10, 48);
  
}//drawPaper


public boolean isInVisualisation(int x, int y) {
  
   // rect(vis_left_mm*virtual_paper_ppmm+virtual_paper_left,vis_top_mm*virtual_paper_ppmm+virtual_paper_top,vis_width_mm*virtual_paper_ppmm,vis_height_mm*virtual_paper_ppmm);
   if (
     (x>vis_left_mm*virtual_paper_ppmm+virtual_paper_left&&x<vis_left_mm*virtual_paper_ppmm+virtual_paper_left+vis_width_mm*virtual_paper_ppmm)&&
     (y>vis_top_mm*virtual_paper_ppmm+virtual_paper_top&&y<vis_top_mm*virtual_paper_ppmm+virtual_paper_top+vis_height_mm*virtual_paper_ppmm)
   ) {
     return true;
   } else {
     return false; 
   }
   
}
