
// -----------------------------------
// Punkte erzeugen
// -----------------------------------

public void generatePoints() {

  RPoint top_Left= new RPoint(0.0,0.0);
  RPoint bottom_right= new RPoint(0.0,0.0);

  RG.init(this);
  // http://www.ricardmarxer.com/old_geomerative/documentation/rcommand_method_setsegmentator.htm
  RCommand.setSegmentator(RCommand.ADAPTATIVE); 

  // TEXT ------------------------------
  if (Mode.getState(0)) {
    RFont font;
    font = new RFont(fonts[int(Text_Font.getValue())][1], int(Text_Size.getValue()), RFont.LEFT);
    RGroup group;
    group = font.toGroup(Text_Text.getText()+" "+Text_Text_2.getText());
    group.rotate(2*PI/360*Drehen.getValue());
    rawGroupedPoints = group.getPointsInPaths();
    if (rawGroupedPoints==null) {
       rawGroupedPoints= new RPoint[0][0];
    } 
    top_Left=group.getTopLeft();
    bottom_right=group.getBottomRight();
  }
  
  // SVG ------------------------------
  if (Mode.getState(1)) {
    RShape shape;    
    shape = RG.loadShape("svg/"+SVG_Src.getText()+".svg");
    shape.rotate(2*PI/360*Drehen.getValue());
    shape.scale(SVG_Scale.getValue());
    rawGroupedPoints = shape.getPointsInPaths(); 
    if (rawGroupedPoints==null) {
       rawGroupedPoints= new RPoint[0][0];
    }
    top_Left=shape.getTopLeft();
    bottom_right=shape.getBottomRight();
  }

  float vis_most_left=1000000;
  float vis_most_top=1000000;
  float vis_most_right=-1000000;
  float vis_most_bottom=-1000000;

  if(rawGroupedPoints.length>0){
    for (int i=0; i<rawGroupedPoints.length; i++) {
      for (int ii=0; ii<rawGroupedPoints[i].length; ii++) {
        if (rawGroupedPoints[i][ii].x<vis_most_left) {
          vis_most_left=rawGroupedPoints[i][ii].x;
        }
        if (rawGroupedPoints[i][ii].y<vis_most_top) {
          vis_most_top=rawGroupedPoints[i][ii].y;
        }
        if (rawGroupedPoints[i][ii].x>vis_most_right) {
          vis_most_right=rawGroupedPoints[i][ii].x;
        }
        if (rawGroupedPoints[i][ii].y>vis_most_bottom) {
          vis_most_bottom=rawGroupedPoints[i][ii].y;
        }
      }  
    }
  
    // alle punkte auf 0 plus gegebene abstände verschieben
    for (int i=0; i<rawGroupedPoints.length; i++) {
      for (int ii=0; ii<rawGroupedPoints[i].length; ii++) {
        rawGroupedPoints[i][ii].x=rawGroupedPoints[i][ii].x-vis_most_left+vis_left_mm;
        rawGroupedPoints[i][ii].y=rawGroupedPoints[i][ii].y-vis_most_top+vis_top_mm;
      }
    }
    
    // most variablen auch verschieben
    vis_most_right=vis_most_right-vis_most_left+vis_left_mm;
    vis_most_bottom=vis_most_bottom-vis_most_top+vis_top_mm;
    vis_most_left=vis_left_mm;
    vis_most_top=vis_top_mm;
  } else {
     vis_most_left=0; 
     vis_most_top=0;
     vis_most_right=0;
     vis_most_bottom=0;
  }

  // Höhe und Breite ausrechnen
  vis_width_mm=vis_most_right-vis_most_left;
  vis_height_mm=vis_most_bottom-vis_most_top;
 
}
