
// --------------------
// UI
// --------------------

//CONTROLLER  -----------------

RadioButton Mode;

Textfield Text_Text;    //getText()
Textfield Text_Text_2;    //getText()
Textfield Text_Text_3;    //getText()
Numberbox Text_Size;    //getValue()
DropdownList Text_Font;
Textlabel Text_Font_Label;
Textlabel Text_Text_Label;
Textlabel Text_Size_Label;

Textfield SVG_Src;
Numberbox SVG_Scale;
Textlabel SVG_Src_Label;
Textlabel SVG_Scale_Label;

Numberbox Abstand_oben;
Numberbox Abstand_links;
Button Center;

Knob Drehen;

DropdownList Papier;

Button StopGo;

Button Pause;

Button Setup;

int tintcolor=color(255,100,100);
int tintpressedcolor=color(220,80,80);
int okcolor=color(0, 230, 200);
int backcolor=color(20);

public void GenerateGeneralControl() {

  // Mode ----------------------------------
  Mode = cp5.addRadioButton("Mode")
    .setPosition(10, control_zero_height+10)
    .setColorForeground(color(120))
    .setColorActive(color(255))
    .setColorLabel(color(255))
    .setSize(20, 20)
    .setItemsPerRow(1)
    .setSpacingColumn(0)
    .setSpacingRow(10)
    .addItem("Text", 0)
    .addItem("SVG", 1)
    .toUpperCase(false)
    .setColorBackground(backcolor)
    .setColorActive(tintcolor)
    .hideLabels();

   cp5.addTextlabel("Mode_Text_Label")
    .setText("Text")        
    .setPosition(36, control_zero_height+11)
    .setFont(control_font);

   cp5.addTextlabel("Mode_SVG_Label")
    .setText("SVG")        
    .setPosition(36, control_zero_height+41)
    .setFont(control_font);
    
  // Text -------------------------------
   Text_Text = cp5.addTextfield("Text_Text")
    .setPosition(114+1, control_zero_height+10)
    .setSize(140-2, 20)
    .setFont(control_font)
    .setCaptionLabel("")
    .setColor(color(255))
    .setColorBackground(backcolor)
    .setColorForeground(color(0))
    .setColorActive(tintcolor)
    .setAutoClear(false);

   Text_Text_2 = cp5.addTextfield("Text_Text_2")
    .setPosition(114+1, control_zero_height+40)
    .setSize(140-2, 20)
    .setFont(control_font)
    .setCaptionLabel("")
    .setColor(color(255))
    .setColorBackground(backcolor)
    .setColorForeground(color(0))
    .setColorActive(tintcolor)
    .setAutoClear(false);
  
   Text_Text_3 = cp5.addTextfield("Text_Text_3")
    .setPosition(114+1, control_zero_height+70)
    .setSize(140-2, 20)
    .setFont(control_font)
    .setCaptionLabel("")
    .setColor(color(255))
    .setColorBackground(backcolor)
    .setColorForeground(color(0))
    .setColorActive(tintcolor)
    .setAutoClear(false);
    
  Text_Size = cp5.addNumberbox("Text_Size")
    .setPosition(323, control_zero_height+40)
    .setSize(140, 20)
    .setScrollSensitivity(0.6)
    .setDirection(Controller.HORIZONTAL) // change the control direction to left/right
    .setRange(0, 2000)
    .setValue(180)
    .setCaptionLabel("")
    .setColorBackground(backcolor)
    .setColorForeground(color(255))
    .setDecimalPrecision(0)
    .setColorActive(tintcolor);
    
  Text_Font_Label = cp5.addTextlabel("Text_Font_Label")
    .setText("Schriftart")        
    .setPosition(259, control_zero_height+11)    // 180 verschoben
    .setFont(control_font);

  Text_Text_Label = cp5.addTextlabel("Text_Text_Label")
    .setText("Text")        
    .setPosition(79, control_zero_height+11)
    .setFont(control_font);

  Text_Size_Label = cp5.addTextlabel("Text_Size_Label")
    .setText("Größe")        
    .setPosition(259, control_zero_height+41)
    .setFont(control_font);
    
  // SVG ----------------------------------
  SVG_Src = cp5.addTextfield("SVG_Src")
    .setPosition(140+1, control_zero_height+10)
    .setSize(140-2, 20)
    .setFont(control_font)
    .setCaptionLabel("")
    .setColor(color(255))  
   // .setText("Wheel")
    .setColorBackground(backcolor)
    .setColorForeground(backcolor)
    .setColorActive(tintcolor)
    .setAutoClear(false);

   SVG_Scale = cp5.addNumberbox("SVG_Scale")
    .setPosition(140, control_zero_height+40)
    .setSize(140, 20)
    .setMultiplier(0.005)
    .setScrollSensitivity(0.001)
    .setDirection(Controller.HORIZONTAL) // change the control direction to left/right
    .setRange(0.01, 4)
    .setValue(0.3)
    .setCaptionLabel("")
    .setColorBackground(backcolor)
    .setColorForeground(color(255))
    .setColorActive(tintcolor);

  SVG_Src_Label = cp5.addTextlabel("SVG_Src_Label")
    .setText("Datei")        
    .setPosition(80, control_zero_height+11)
    .setFont(control_font);

  SVG_Scale_Label = cp5.addTextlabel("SVG_Scale_Label")
    .setText("Scale")        
    .setPosition(80, control_zero_height+41)
    .setFont(control_font);
            
  // Drehung -------------------------------
  Drehen = cp5.addKnob("Drehen")
    .setRange(-180, 180)
    .setValue(0)
    .setPosition(592, control_zero_height+40)
    .setRadius(25)
    .setNumberOfTickMarks(72)
    .setTickMarkWeight(0)
    .setTickMarkLength(0)
    .snapToTickMarks(true)
    .setCaptionLabel("")
    .setDecimalPrecision(0) 
    .setDragDirection(Knob.HORIZONTAL)
    .setColorBackground(backcolor)
    .setColorForeground(color(255))
    .setColorActive(tintcolor)
    .setViewStyle(Knob.ELLIPSE)
    .showTickMarks(false)
    .setShowAngleRange(false);

  cp5.addTextlabel("Drehen_Label")
    .setText("Drehen")        
    .setPosition(592+2, control_zero_height+11)
    .setFont(control_font);

  // Abstand -------------------------------
  Abstand_oben = cp5.addNumberbox("Abstand_oben")
    .setPosition(522, control_zero_height+10)
    .setSize(60, 20)
    .setScrollSensitivity(0.6)
    .setDirection(Controller.HORIZONTAL) // change the control direction to left/right
    .setRange(0, 2000)
    .setValue(0)
    .setCaptionLabel("")
    .setColorBackground(backcolor)
    .setColorForeground(color(255))
    .setDecimalPrecision(0)
    .setColorActive(tintcolor);

  Abstand_links = cp5.addNumberbox("Abstand_links")
    .setPosition(522, control_zero_height+40)
    .setSize(60, 20)
    .setScrollSensitivity(0.6)
    .setDirection(Controller.HORIZONTAL) // change the control direction to left/right
    .setRange(0, 2000)
    .setValue(0)
    .setCaptionLabel("")
    .setColorBackground(backcolor)
    .setColorForeground(color(255))
    .setDecimalPrecision(0)
    .setColorActive(tintcolor);
    
  cp5.addTextlabel("Abstand_oben_Label")
    .setText("Oben")        
    .setPosition(479, control_zero_height+11)
    .setFont(control_font);

  cp5.addTextlabel("Abstand_links_Label")
    .setText("Links")        
    .setPosition(479, control_zero_height+41)
    .setFont(control_font);

  // Center -------------------------------
  Center = cp5.addButton("Center")
    .setPosition(484, control_zero_height+70)
    .setSize(98, 20)
    .setCaptionLabel("Zentrieren")
    .setColorActive(tintpressedcolor)
    .setColorBackground(backcolor)
    .setColorForeground(tintcolor);
    
  Center.getCaptionLabel().toUpperCase(false);
    
  // Font ---------------------------------
  //muss zuletzt erfolgen, da sonst andere Felder auf hoeerer Ebene sind
  Text_Font = cp5.addDropdownList("Text_Font")
    .setPosition(323, control_zero_height+31)  
    .setSize(140, 20)
    .setItemHeight(20)    //Hoehe jedes Eintrags
    .setBarHeight(20)        //Hoehe des Balkens
    .setHeight(80)          //Hoehe der ausgeklappten Liste
    .setColorActive(color(255, 128))   
    .setValue(1.0)
    .toUpperCase(false)
    .setColorBackground(backcolor)
    .setColorForeground(tintcolor);

  //Caption Label
  Text_Font.captionLabel()  .set("");
  Text_Font.captionLabel()  .style().marginTop = 1;    //Textausrichtung in DropDown-Hauptfeld
  Text_Font.captionLabel()  .style().marginLeft = 0;

  //Value Label
  Text_Font.valueLabel().style().marginTop = 2;

  //Add item
  for (int i=0;i<fonts.length;i++) {
    Text_Font.addItem(fonts[i][0], i);
  }
  Text_Font.scroll(0);  //Bei welchem Item der Scrollbalken startet
  
  // Papier -------------------------------
   //muss zuletzt erfolgen, da sonst andere Felder auf hoeerer Ebene sind
  Papier = cp5.addDropdownList("Papier")
    .setPosition(663, control_zero_height+31)  
    .setSize(140, 20)
    .setItemHeight(20)    //Hoehe jedes Eintrags
    .setBarHeight(20)        //Hoehe des Balkens
    .setHeight(80)          //Hoehe der ausgeklappten Liste
    .setColorActive(color(255, 128))   
    .setValue(1.0)
    .toUpperCase(false)
    .setColorBackground(backcolor)
    .setColorForeground(tintcolor);

  //Caption Label
  Papier.captionLabel()  .set("");
  Papier.captionLabel()  .style().marginTop = 1;    //Textausrichtung in DropDown-Hauptfeld
  Papier.captionLabel()  .style().marginLeft = 0;

  //Value Label
  Papier.valueLabel().style().marginTop = 2;

  //Add item
  //Papier.addItem("DIN A4", 0);
  //Papier.addItem("1 x 1,90m", 1);
  for (int i=0;i<papers.length;i++) {
    Papier.addItem(papers[i][0], i);
  }
  Papier.scroll(0);  //Bei welchem Item der Scrollbalken startet
  
  /*
  cp5.addTextlabel("Papier_Label")
    .setText("Papier")        
    .setPosition(663-5, control_zero_height+41)
    .setFont(control_font);*/
    
  // Stopgo -------------------------------
  StopGo = cp5.addButton("StopGo")
    .setPosition(width-90-90-90-6, control_zero_height+10)
    .setSize(82, 80)
    .setCaptionLabel("--")
    .setColorActive(tintpressedcolor)
    .setColorBackground(backcolor)
    .setColorForeground(tintcolor);
    
    StopGo.getCaptionLabel().toUpperCase(false);
       
  // Pause -------------------------------
  Pause = cp5.addButton("Pause")
    .setPosition(width-90-90-4, control_zero_height+10)
    .setSize(82, 80)
    .setCaptionLabel("---")
    .setColorActive(tintpressedcolor)
    .setColorBackground(backcolor)
    .setColorForeground(tintcolor);

    Pause.getCaptionLabel().toUpperCase(false);
   
  // Setup -------------------------------
  Setup = cp5.addButton("Setup")
    .setPosition(width-90-2, control_zero_height+10)
    .setSize(82, 80)
    .setCaptionLabel("Verbinden")
    .setColorActive(tintpressedcolor)
    .setColorBackground(backcolor)
    .setColorForeground(tintcolor);
    
    Setup.getCaptionLabel().toUpperCase(false);
    
    
}

//MODE EVENT ---------------------------------------------------

public void showTextControl() { // Text elemente anzeigen

  SVG_Src.hide();
  SVG_Scale.hide();
  SVG_Src_Label.hide();
  SVG_Scale_Label.hide();
  
  Text_Size.show();
  Text_Font.show();
  Text_Text.show();
  Text_Text_2.show();
  Text_Text_3.show();
  Text_Font_Label.show();
  Text_Text_Label.show();
  Text_Size_Label.show();
  
}

public void showSVGControl() { // svg elemente anzeigen

  SVG_Src.show();
  SVG_Scale.show();
  SVG_Src_Label.show();
  SVG_Scale_Label.show();
  
  Text_Size.hide();
  Text_Font.hide();
  Text_Text.hide();
  Text_Text_2.hide();
  Text_Text_3.hide();
  Text_Font_Label.hide();
  Text_Text_Label.hide();
  Text_Size_Label.hide();
 
}

public void disableControls() {
  if (is_controls_enabled) {
    is_controls_enabled=false;
    Mode.setVisible(false);
    Text_Text.lock();
    Text_Text_2.lock();
    Text_Text_3.lock();
    Text_Size.lock();
    Text_Font.setVisible(false);
    SVG_Src.lock();
    SVG_Scale.lock();
    Abstand_oben.lock();
    Abstand_links.lock();
    Center.lock();
    Drehen.lock();
    Papier.setVisible(false);
  }
}

public void enableControls() {
  if (!is_controls_enabled) {
    is_controls_enabled=true;
    Mode.setVisible(true);
    Text_Text.unlock();
    Text_Text_2.unlock();
    Text_Text_3.unlock();
    Text_Size.unlock();
    Text_Font.setVisible(true);
    SVG_Src.unlock();
    SVG_Scale.unlock();
    Abstand_oben.unlock();
    Abstand_links.unlock();
    Center.unlock();
    Drehen.unlock();
    Papier.setVisible(true);
  }
}

//CONTROL EVENT ---------------------------------------------------

public void controlEvent(ControlEvent theEvent) {

  if(theEvent.isFrom(Abstand_oben)) {
     vis_top_mm=Abstand_oben.getValue();
  }

  if(theEvent.isFrom(Abstand_links)) {
    vis_left_mm=Abstand_links.getValue();
  }
  
  if(theEvent.isFrom(Mode)) {
    if (Mode.getState(0)) {
      showTextControl();
    } else {
      showSVGControl();
    }
  }
  
  if(theEvent.isFrom(Papier)) {
    paper_width_mm=Integer.parseInt(papers[int(Papier.getValue())][1]);
    paper_height_mm=Integer.parseInt(papers[int(Papier.getValue())][2]);
  }   
  
  please_drawPaper=true;

}

//Bangs ---------------------------------------------------

public void Center() { // objekt zentrieren
  Abstand_links.setValue((paper_width_mm-vis_width_mm)/2);
  Abstand_oben.setValue((paper_height_mm-vis_height_mm)/2);   
}

public void StopGo() {
  if (!is_malokal_running) {
    OscMessage message = new OscMessage("/ml/q/start"); 
    message.add(command_list_length);
    malokalSendOSC(message);
  } else {
    OscMessage message = new OscMessage("/ml/q/start"); 
    message.add(0);
    malokalSendOSC(message);
  }
  StopGo.setCaptionLabel("...");
}

public void Pause() {
    OscMessage message = new OscMessage("/ml/q/pause"); 
    message.add(0);
    malokalSendOSC(message);
    Pause.setCaptionLabel("...");
}

public void Setup() { // Malokal einrichten

    InetAddress inet;
    String inet_ip="";
    String inet_name="";

    try {
      inet = InetAddress.getLocalHost();
      
      inet_ip=inet.getHostAddress();
      inet_name=inet.getHostName();
      
      if (inet_name.toLowerCase().contains(".local")&&inet_ip.toLowerCase().contains("192.168.0.")) {
        is_malokal_connected=true;
       // println(is_malokal_connected);
        // Alles gut, und ip bekannt
        OscMessage message = new OscMessage("/ml/setup"); 
        
           message.add(Integer.parseInt(inet_ip.split("\\.")[0]));
           message.add(Integer.parseInt(inet_ip.split("\\.")[1]));
           message.add(Integer.parseInt(inet_ip.split("\\.")[2]));
           message.add(Integer.parseInt(inet_ip.split("\\.")[3]));
        
        malokalSendOSC(message);
      } else {
        is_malokal_connected=false;
      }
      
    } catch (Exception e) {
      e.printStackTrace();
    }

}

//Maus ---------------------------------------------------

int maus_init_x;
int maus_init_y;

float vis_left_mm_init;
float vis_top_mm_init;


void mousePressed() {

  maus_init_x=mouseX;
  maus_init_y=mouseY;
  
  vis_left_mm_init=vis_left_mm;
  vis_top_mm_init=vis_top_mm;
  
}

void mouseDragged() {
  
  if (isInVisualisation(mouseX,mouseY)) {
    vis_left_mm=floor(vis_left_mm_init+(mouseX-maus_init_x)/virtual_paper_ppmm);
    vis_top_mm=floor(vis_top_mm_init+(mouseY-maus_init_y)/virtual_paper_ppmm);
    Abstand_links.setValue(vis_left_mm);
    Abstand_oben.setValue(vis_top_mm);
  }
  
  is_mouse_active=true;
  last_maus_moved=millis();

}

void mouseMoved() {
  is_mouse_active=true;
  last_maus_moved=millis();
}
